-- Game

print("Loading game module...")

game = { }
game.nump = 0
game.clients = { }

lbuttons = 0
rbuttons = 0
lslider = { value = 0 }
rslider = { value = 0 }
rside = nil
suitin = { { text = "" }, { text = "localhost" }, { text = "22122" } }
debugplayer = 0

function game.init(n)
  
	if n == nil and game.nump < 3 then
    print("Game cannot initialize with less than 3 players!")
    return
  end
  
	if n ~= nil then
    game.nump = n
  end
  
	game.phase = "setmode"
	game.phasereset()
  
end

function game.update(dt)
  
	if game.phase == "setmode" then
		
	elseif game.mode == "davidoff" or game.mode == "plotkin" or game.mode == "teset" then
    
		if game.phase == "day" then
      
			local adv = true
			for i, p in pairs(game.players) do -- Cycles through the player list and
				if p.voted == false and p.dead == false then -- If they ain't dead and they haven't voted, wait
					adv = false
				end
			end
      
			if adv == true then
				game.advance()
			end
      
		elseif game.phase == "night" then
      
			local adv = true
			for i, p in pairs(game.players) do
				if p.voted == false and p.dead == false then -- Innocents do nothing at night in a Davidoff game, however, since actions are shown, they abstain
					adv = false
				end
			end
      
			if adv == true then
				game.advance()
			end
      
		end
	end
	game.screenupdate(dt)
end

function game.screenupdate(dt)
	-- Left side
	suit.layout:reset(64, 64 - lslider.value)
	if game.phase == nil or game.phase == "main" then
    
		suit.Label("Welcome to LANWolf!", suit.layout:row(lg.getWidth()/2 - 128, 48))
		suit.layout:row()
    
		if suit.Button("Start Game", suit.layout:row()).hit then
			game.phase = "hostmain"
			rside = "clientlist"
			initserver()
		end
		suit.layout:row()
    
		if suit.Button("Join Game", suit.layout:row()).hit then
			game.phase = "joingame"
		end
		suit.layout:row()
    
		if suit.Button("Close", suit.layout:row()).hit then
			le.quit()
		end
    
		lbuttons = 4
    
	elseif game.phase == "hostmain" then
    
		if suit.Button("Start Game with "..game.nump.." Players", suit.layout:row(lg.getWidth()/2 - 128, 48)).hit then
			game.init()
		end
		suit.layout:row()
    
		if suit.Button("Cancel hosting", suit.layout:row()).hit then
			game.phase = "main"
		end
    
		lbuttons = 2
    
	elseif game.phase == "setmode" then
    
		suit.Label("Please select a ruleset:", suit.layout:row(lg.getWidth()/2 - 128, 48))
		suit.layout:row()
    
		if suit.Button("Davidoff", suit.layout:row()).hit then
      
			print("Game mode is Davidoff")
			game.mode = "davidoff"
			game.advance()
      
      if server ~= nil then
        server:emitToAll("mode update", game.mode)
      end
      
		end
		suit.layout:row()
    
		if suit.Button("Plotkin", suit.layout:row()).hit then
      
      print("Game mode is Plotkin")
      game.mode = "plotkin"
      game.advance()
      
      if server ~= nil then
        server:emitToAll("mode update", game.mode)
      end
      
    end
		suit.layout:row()
    
    if suit.Button("Teset", suit.layout:row()).hit then
      
      print("Game mode is Teset")
      game.mode = "teset"
      game.advance()
      
      if server ~= nil then
        server:emitToAll("mode update", game.mode)
      end
      
    end
    suit.layout:row()
    
		lbuttons = 4
    
  elseif game.phase == "joingame" then
    
    suit.Label("Enter a handle, IP Address, and port for the server:", suit.layout:row(lg.getWidth()/2 - 128, 48))
    suit.layout:row()
    
    suit.Label("Nickname:", suit.layout:row())
    suit.Input(suitin[1], suit.layout:row())
    suit.layout:row()
    
    suit.Label("IP Address of Server:", suit.layout:row())
    suit.Input(suitin[2], suit.layout:row())
    suit.layout:row()
    
    suit.Label("Port of Server:", suit.layout:row())
    suit.Input(suitin[3], suit.layout:row())
    suit.layout:row()
    
    if suit.Button("Join Game", suit.layout:row()).hit then
      initclient(suitin[2].text, suitin[3].text)
    end
    suit.layout:row()
    
    lbuttons = 7
    
	elseif game.phase == "day" and debugplayer ~= 0 then
    
		suit.Label("Vote a character to lynch!", suit.layout:row(lg.getWidth()/2 - 128, 48))
		suit.layout:row()
    
		if suit.Button("Abstain", suit.layout:row()).hit then
			if debugplayer ~= 0 then
				game.players[debugplayer].vote(#game.players + 1)
			end
		end
		suit.layout:row()
    
		for i, p in pairs(game.players) do
			if (not p.dead) and debugplayer ~= 0 and suit.Button("Player "..i, suit.layout:row()).hit then
				game.players[debugplayer].vote(i)
			end
			suit.layout:row()
		end
    
		lbuttons = #game.players + 2
    
  elseif game.phase == "night" and debugplayer ~= 0 then
    
		suit.Label("Select a character to act on!", suit.layout:row(lg.getWidth()/2 - 128, 48))
		suit.layout:row()
    
		if suit.Button("Abstain", suit.layout:row()).hit then
			if debugplayer ~= 0 then
				game.players[debugplayer].vote(#game.players + 1)
			end
		end
		suit.layout:row()
    
		for i, p in pairs(game.players) do
			if (not p.dead) and debugplayer ~= 0 and game.players[debugplayer].role ~= "Innocent" and suit.Button("Player "..i, suit.layout:row()).hit then
				game.players[debugplayer].vote(i)
			end
			suit.layout:row()
		end
    
		lbuttons = #game.players + 2
    
  elseif game.phase == "day" and client ~= nil and playernum ~= nil then
    
		suit.Label("Vote a character to lynch!", suit.layout:row(lg.getWidth()/2 - 128, 48))
		suit.layout:row()
    
		if suit.Button("Abstain", suit.layout:row()).hit then
			client:emit("vote", #game.players + 1)
		end
		suit.layout:row()
    
		for i, p in pairs(game.players) do
			if (not p.dead) and suit.Button("Player "..i, suit.layout:row()).hit then
				client:emit("vote", i)
			end
			suit.layout:row()
		end
    
		lbuttons = #game.players + 2
    
  elseif game.phase == "night" and client ~= nil and playernum ~= nil then
		suit.Label("Select a character to act on!", suit.layout:row(lg.getWidth()/2 - 128, 48))
		suit.layout:row()
    
		if suit.Button("Abstain", suit.layout:row()).hit then
			client:emit("vote", #game.players + 1)
		end
		suit.layout:row()
    
		for i, p in pairs(game.players) do
			if (not p.dead) and game.players[playernum].role ~= "Innocent" and suit.Button("Player "..i, suit.layout:row()).hit then
				client:emit("vote", i)
			end
			suit.layout:row()
		end
    
		lbuttons = #game.players + 2
    
  elseif game.phase == "day" then
    suit.Label("DAY:\n\nOnce all players have voted, the game will advance (so be careful!)", suit.layout:row(lg.getWidth()/2 - 128, 48))
    suit.layout:row()
    
    lbuttons = 1
    
	elseif game.phase == "night" then
    
		suit.Label("NIGHT:\n\nOnce all players have acted (or abstained), the game will advance (so be careful!)", suit.layout:row(lg.getWidth()/2 - 128, 48))
    suit.layout:row()
    
    lbuttons = 1
    
	end
	
	-- Left side slider
	if lbuttons * 96 > lg.getHeight() - 128 then
    
		if lslider.min ~= (lbuttons * 96) - (lg.getHeight() - 128) then
			lslider.min = (lbuttons * 96) - (lg.getHeight() - 128)
			lslider.value = 0
			lslider.max = 0
		end
    
		suit.Slider(lslider, {vertical = true}, lg.getWidth()/2 - 128 + 80, 64, 32, lg.getHeight() - 128)
	
  end
	
	-- Right Side
	suit.layout:reset(lg.getWidth()/2 + 64, 64 - rslider.value)
  
	if game.phase == nil or game.phase == "main" then
    
		suit.Label("News feed", suit.layout:row(lg.getWidth()/2 - 128, 48))
		suit.layout:row()
    
		suit.Label("This will eventually be determined by update or something...", suit.layout:row())
    
		rbuttons = 2
    
  elseif game.phase == "setmode" then
    
    suit.Label("Davidoff: In a Davidoff game, 1/3 of the players are Mafia, ensuring a fair fight; there are no special roles\n\nPlotkin: In a Plotkin game, there are always only 2 Mafia, ensuring a harder game for Innocents; there are no special roles\n\nTeset: In a Teset (typo of test) game, 1/3 of the players are Mafia, ensuring a fair fight; the Godfather role is playable\n\n", suit.layout:row(lg.getWidth()/2 - 128, 48))
    suit.layout:row()
    
    rbuttons = 4
    
	elseif (game.phase == "day" or game.phase == "night") and (debugplayer ~= 0 or client ~= nil) then
    
    suit.Label("Player "..(playernum or debugplayer), suit.layout:row(lg.getWidth()/2 - 128, 48))
    suit.layout:row()
    
    suit.Label("You are a "..game.players[(playernum or debugplayer)].role, suit.layout:row())
    suit.layout:row()
    
    local objective = "Your objective is "
    if game.mode == "davidoff" or game.mode == "plotkin" then
      if game.players[(playernum or debugplayer)].role == "Innocent" then
        objective = objective.."to lynch all Mafia members!"
      elseif game.players[(playernum or debugplayer)].role == "Mafioso" then
        objective = objective.."to kill all Innocents!\n\nAbilities:\nAt night, vote to kill a member of the village"
      end
    elseif game.mode == "teset" then
      if game.players[(playernum or debugplayer)].role == "Innocent" then
        objective = objective.."to lynch all Mafia members!"
      elseif game.players[(playernum or debugplayer)].role == "Mafioso" then
        objective = objective.."to kill all Innocents!\n\nAbilities:\nAt night, vote to kill a member of the village, but your vote is overruled by the Godfather"
      elseif game.players[(playernum or debugplayer)].role == "Godfather" then
        objective = objective.."to kill all Innocents!\n\nAbilities:\nAt night, command your Mafioso to kill a member of the village. If there is no Mafioso, then YOU do the killing"
      end
    end
    
    suit.Label(objective, suit.layout:row())
    suit.layout:row()
    
		rbuttons = 4
    
	elseif rside == "clientlist" then
    
    suit.Label("Connected:", suit.layout:row(lg.getWidth()/2 - 128, 48))
    suit.layout:row()
    
		for i = 1, game.nump do
			suit.Label("Player "..game.clients[i].ind..", "..game.clients[i].username, suit.layout:row())
      suit.layout:row()
		end
    
		rbuttons = game.nump
    
  elseif rside == "playerlist" then
    
    suit.Label("Votes", suit.layout:row(lg.getWidth()/2 - 128, 48))
    suit.layout:row()
    
    if game.phase == "day" then
      
      for i, p in pairs(game.players) do
        
        if p.dead then
          suit.Label("Player "..p.num.." is dead...", suit.layout:row())
          
        elseif p.voted and p.vfor <= #game.players then
          suit.Label("Player "..p.num.." votes against "..p.vfor, suit.layout:row())
          
        elseif p.voted and p.vfor > #game.players then
          suit.Label("Player "..p.num.." abstains", suit.layout:row())
          
        else
          suit.Label("Player "..p.num.." is waiting", suit.layout:row())
          
        end
        suit.layout:row()
        
      end
      
    elseif game.phase == "night" then
      
      for i, p in pairs(game.players) do
        
        if p.dead then
          suit.Label("Player "..p.num.." is dead...", suit.layout:row())
          
        elseif p.voted then
          suit.Label("Player "..p.num.." has acted", suit.layout:row())
          
        else
          suit.Label("Player "..p.num.." is waiting", suit.layout:row())
          
        end
        suit.layout:row()
        
      end
      
    else
      for i, p in pairs(game.players) do
        suit.Label("Player "..p.num, suit.layout:row())
        suit.layout:row()
      end
    end
    
    rbuttons = game.nump
	end
	
	-- Right side slider
	if rbuttons * 96 > lg.getHeight() - 128 then
    
		if rslider.min ~= (rbuttons * 96) - (lg.getHeight() - 128) then
			rslider.min = (rbuttons * 96) - (lg.getHeight() - 128)
			rslider.value = 0
			rslider.max = 0
		end
    
		suit.Slider(rslider, {vertical = true}, lg.getWidth() - 56, 72, 32, lg.getHeight() - 128)
    
	end
end

function game.phasereset()
  
	game.vpool = { }
  if game.players ~= nil then
    for i, p in pairs(game.players) do
      if game.vpool[p.align] == nil then
        game.vpool[p.align] = { }
      end
    end
  end
  
	if game.players ~= nil then
    
		for i, p in pairs(game.players) do
			p.voted = false
      p.vfor = 0
      p.visits = { }
			if p.dead == true and not p.hasbeendead then
				p.hasbeendead = true
				print("Player "..p.num.." has died!")
			end
		end
    
	end
  
end

function game.advance()
  
	print("Advancing...")
	if game.phase == "setmode" then
    
		game.phase = "setup"
    
		if game.mode == "davidoff" then
      
			game.rolelist = { }
			for i = 1, game.nump do
				table.insert(game.rolelist, "Innocent")
			end
      
			local mafs = math.round(game.nump / 3)
			for i = 1, mafs do
				game.rolelist[i] = "Mafioso"
			end
      
			print("There are "..mafs.." mafioso present...")
			game.setupplayers()
			game.advance()
      
    elseif game.mode == "plotkin" then
      
      game.rolelist = { }
      for i = 1, game.nump do
        table.insert(game.rolelist, "Innocent")
      end
      
      local mafs = math.random(1, game.nump)
      game.rolelist[mafs] = "Mafioso"
      
      while game.rolelist[mafs] == "Mafioso" do
        mafs = math.random(1, game.nump)
      end
      
      game.rolelist[mafs] = "Mafioso"
      game.setupplayers()
      game.advance()
      
    elseif game.mode == "teset" then
      
      game.rolelist = { }
      for i = 1, game.nump do
        table.insert(game.rolelist, "Innocent")
      end
      
      game.rolelist[1] = "Godfather"
      game.rolelist[2] = "Mafioso"
      
			game.setupplayers()
			game.advance()
      
		end
    
	elseif game.phase == "setup" then
    
		game.phase = "day"
    if server ~= nil then
      server:emitToAll("plupdate", Tserial.pack(game.players, true))
      server:emitToAll("phase", "day")
    end
    
	elseif game.phase == "day" then
    
		game.assessvotes()
		game.phasereset()
		game.phase = "night"
		game.assesswins()
    
    if server ~= nil then
      server:emitToAll("plupdate", Tserial.pack(game.players, true))
      server:emitToAll("phase", "night")
    end
    
	elseif game.phase == "night" then
    
		game.assessvotes()
		game.phasereset()
		game.phase = "day"
		game.assesswins()
    
    if server ~= nil then
      server:emitToAll("plupdate", Tserial.pack(game.players, true))
      server:emitToAll("phase", "day")
    end
    
	end
end

function game.setupplayers()
  
	game.players = { }
	for i = 1, game.nump do
		table.insert(game.players, player.new())
	end
  
	for i, p in pairs(game.players) do
		print("Player "..i.." is a "..p.role)
		if server ~= nil then
			local to = server:getClientByIndex(i)
			to:emit("assign role", p.role)
		end
	end
  
end

function game.playersliving()
  
  local living = 0
  for i, p in pairs(game.players) do
    if not p.dead then
      living = living + 1
    end
  end
  
  return living
  
end

function game.assessvotes()
  
  if game.mode == "davidoff" or game.mode == "plotkin" or game.mode == "teset" then
    
    if game.phase == "day" then
      
      local dvtab = { }
      for i, p in pairs(game.players) do
        if p.role == "Mayor" then
          table.mod(dvtab, p.vfor, 3)
        else
          table.mod(dvtab, p.vfor, 1)
        end
      end
      
      local highcard = {0, 0}
      for i, v in pairs(dvtab) do
        if v > highcard[1] then
          highcard = {v, i}
        end
      end
      
      for i, v in pairs(dvtab) do
        if v == highcard[1] and i ~= highcard[2] then
          highcard = {0, 0}
        end
      end
      
      if highcard[2] > #game.players or highcard[1] == 0 then
        print("Nobody was lynched...")
        
      elseif highcard[2] ~= 0 then
        game.players[highcard[2]].die()
        
      end
      
    elseif game.phase == "night" then
      
      for i, p in pairs(game.players) do
        if p.vgroup == nil then
          if p.role == "Godfather" then
            table.mod(game.vpool[p.align], p.vfor, 10000)
          else
            table.mod(game.vpool[p.align], p.vfor, 1)
          end
        else
          table.mod(game.vpool[p.vgroup], p.vfor, 1)
        end
      end
      
      for j, pool in pairs(game.vpool) do
        local highcard = {0, 0}
        for i, v in pairs(pool) do
          print("Checking "..j.." pool's votes against player "..i.." at value "..v)
          if v > highcard[1] then
            highcard = {v, i}
          end
        end
        
        for i, v in pairs(pool) do
          if v == highcard[1] and i ~= highcard[2] and i ~= 6 then
            highcard = {0, 0}
          end
        end
        
        if highcard[2] > #game.players or highcard[1] == 0 then
          print("No action from the "..j.." pool.")
          
        elseif highcard[2] ~= 0 then
          if j == "Mafia" then
            game.players[highcard[2]].die()
            table.insert(game.players[highcard[2]].visits, player.kmaf(highcard[2]))
          end
          
        end
        
      end
      
    end
    
  end
  
end

function game.assesswins()
  
	if game.mode == "davidoff" or game.mode == "plotkin" or game.mode == "teset" then
    
		local mafcount, innocount = 0, 0
		for i, p in pairs(game.players) do
			if not p.dead then
        
				if p.align == "Mafia" then
					mafcount = mafcount + 1
          
				elseif p.align == "Innocent" then
					innocount = innocount + 1
          
				end
        
			end
		end
    
		if innocount <= 1 and mafcount > 0 then
			print("Mafia wins! ------------------>")
			game.init()
      
		elseif mafcount == 0 then
			print("Innocents win! --------------->")
		end
    
	end
  
end

print("Game module loaded")