-- Main
-- 
-- Ultimate LANWolf


la  = love.audio
le  = love.event
lfs = love.filesystem
lf  = love.font
lg  = love.graphics
li  = love.image
lj  = love.joystick
lk  = love.keyboard
lma = love.math
lm  = love.mouse
lp  = love.physics
ls  = love.sound
lsy = love.system
lth = love.thread
lti = love.timer
lt  = love.touch
lw  = love.window

require('libs.lovedebug')
sock = require('libs.sock.sock')
suit = require('libs.suit')
TSerial = require('libs.Tserial')
input = { text = "" }

print(" ")
print("You are playing LANWolf by TheRedRaccoon ^~^ - Made with LOVE")

require('net.server')
require('net.client')
require('game')
require('player')

-- Get IP and display it
require "socket"
local s = socket.udp()
s:setpeername("74.125.115.104",80)
local ip, _ = s:getsockname()
print(ip)
-- Get IP and display it

function love.load()
	math.randomseed(os.time())
	
	for i, a in pairs(arg) do
		if a == "-client" and server == nil then
			initclient()
		end
		if a == "-server" and client == nil then
			initserver()
		end
		if a == "-textonly" then
			textonly = true
		end
	end
  
  lg.setFont(lg.newFont("fonts/CatShop/CatShop.ttf", 22))
end

function love.update(dt)
	if server ~= nil then
		server:update()
	end
	if client ~= nil then
		client:update()
	end
	
	game.update(dt)
	
	lk.updateKeys()
end

function love.draw()
	lg.setColor(255, 255, 255, 255)
	lg.line(lg.getWidth()/2, 0, lg.getWidth()/2, lg.getHeight())
	suit.draw()
end

function love.textinput(t)
	suit.textinput(t)
end

function love.keypressed(key, scancode, isrepeat)
	love.keyboard.keysPressed[key] = true
	love.keyboard.keysDown[key] = true
	suit.keypressed(key)
end

function love.keyreleased(key)
	love.keyboard.keysReleased[key] = true
	love.keyboard.keysDown[key] = false
end

function love.mousemoved(mx, my, mdx, mdy, istouch)
	
end

function love.mousepressed(mx, my, mbutton, istouch)
  
end

function love.mousereleased(mx, my, mbutton, istouch)
  
end

function love.touchmoved(id, mx, my, mdx, mdy, pressure)
  
end

function love.touchpressed(id, mx, my, mdx, mdy, pressure) -- mdx and mdy = 0
  
end

function love.touchreleased(id, mx, my, mdx, mdy, pressure)
  
end

function tell(msg)
	print("===="..msg.."====")
end



-- Various functions to streamline processes


function math.round(num, idp)
	local mult = 10^(idp or 0)
	return math.floor(num * mult + 0.5) / mult
end

function table.mod(t, k, v)
  if t[k] == nil then
    print("TABLE MOD: key "..k.." created")
    t[k] = 0
  end
  print("TABLE MOD: key "..k.." was "..t[k])
  t[k] = t[k] + v
  print("TABLE MOD: key "..k.." is now "..t[k])
end

love.keyboard.keysPressed = { }
love.keyboard.keysReleased = { }
love.keyboard.keysDown = { }

-- returns if specified key was pressed since the last update
function love.keyboard.wasPressed(key)
	if (love.keyboard.keysPressed[key]) then
		return true
	else
		return false
	end
end
-- returns if specified key was released since last update
function love.keyboard.wasReleased(key)
	if (love.keyboard.keysReleased[key]) then
		return true
	else
		return false
	end
end
-- call in end of each love.update to reset lists of pressed\released keys
function love.keyboard.updateKeys()
	love.keyboard.keysPressed = { }
	love.keyboard.keysReleased = { }
end